"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DecisionState = exports.Answer = void 0;
class Answer {
    constructor(ciphertext, digest) {
        this.digest = digest;
        this.ciphertext = ciphertext;
    }
}
exports.Answer = Answer;
class DecisionState {
    constructor(id, owner) {
        this.id = id;
        this.owner = owner;
        this.status = 'asked';
        this.secret = undefined;
        this.answer = undefined;
        this.value = undefined;
    }
    setAnswer(owner, ciphertext, digest) {
        if (this.owner !== owner) {
            throw new Error('Invalid decision owner');
        }
        if (this.status !== 'asked') {
            throw new Error('Invalid decision status');
        }
        this.answer = new Answer(ciphertext, digest);
        this.status = 'answered';
    }
    release() {
        if (this.status !== 'answered') {
            throw new Error('Invalid decision status');
        }
        else {
            this.status = 'releasing';
        }
    }
    addReleased(value) {
        if (this.status !== 'released') {
            throw new Error('Invalid decision status');
        }
        else {
            this.value = value;
        }
    }
    addSecret(owner, secret) {
        if (this.status !== 'releasing') {
            throw new Error('Invalid decision status');
        }
        else if (this.owner !== owner) {
            throw new Error('Invalid decision owner');
        }
        else {
            this.secret = secret;
            this.status = 'released';
        }
    }
}
exports.DecisionState = DecisionState;
//# sourceMappingURL=decision-state.js.map