"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SdkError = exports.InternalError = exports.NoEnoughServers = exports.SerializationError = exports.MalformedCustomEvent = exports.MalformedGameAccountData = exports.InvalidAmount = exports.CantLeave = exports.PlayerNotInGame = exports.NoEnoughPlayers = exports.CustomError = exports.HandleError = void 0;
const borsh_1 = require("@race-foundation/borsh");
class HandleError {
}
exports.HandleError = HandleError;
let CustomError = class CustomError extends HandleError {
    constructor(fields) {
        super();
        this.message = fields.message;
    }
};
CustomError = __decorate([
    (0, borsh_1.variant)(0)
], CustomError);
exports.CustomError = CustomError;
let NoEnoughPlayers = class NoEnoughPlayers extends HandleError {
    constructor(_) {
        super();
    }
};
NoEnoughPlayers = __decorate([
    (0, borsh_1.variant)(1)
], NoEnoughPlayers);
exports.NoEnoughPlayers = NoEnoughPlayers;
let PlayerNotInGame = class PlayerNotInGame extends HandleError {
    constructor(_) {
        super();
    }
};
PlayerNotInGame = __decorate([
    (0, borsh_1.variant)(2)
], PlayerNotInGame);
exports.PlayerNotInGame = PlayerNotInGame;
let CantLeave = class CantLeave extends HandleError {
    constructor(_) {
        super();
    }
};
CantLeave = __decorate([
    (0, borsh_1.variant)(3)
], CantLeave);
exports.CantLeave = CantLeave;
let InvalidAmount = class InvalidAmount extends HandleError {
    constructor(_) {
        super();
    }
};
InvalidAmount = __decorate([
    (0, borsh_1.variant)(4)
], InvalidAmount);
exports.InvalidAmount = InvalidAmount;
let MalformedGameAccountData = class MalformedGameAccountData extends HandleError {
    constructor(_) {
        super();
    }
};
MalformedGameAccountData = __decorate([
    (0, borsh_1.variant)(5)
], MalformedGameAccountData);
exports.MalformedGameAccountData = MalformedGameAccountData;
let MalformedCustomEvent = class MalformedCustomEvent extends HandleError {
    constructor(_) {
        super();
    }
};
MalformedCustomEvent = __decorate([
    (0, borsh_1.variant)(6)
], MalformedCustomEvent);
exports.MalformedCustomEvent = MalformedCustomEvent;
let SerializationError = class SerializationError extends HandleError {
    constructor(_) {
        super();
    }
};
SerializationError = __decorate([
    (0, borsh_1.variant)(7)
], SerializationError);
exports.SerializationError = SerializationError;
let NoEnoughServers = class NoEnoughServers extends HandleError {
    constructor(_) {
        super();
    }
};
NoEnoughServers = __decorate([
    (0, borsh_1.variant)(8)
], NoEnoughServers);
exports.NoEnoughServers = NoEnoughServers;
let InternalError = class InternalError extends HandleError {
    constructor(fields) {
        super();
        this.message = fields.message;
    }
};
__decorate([
    (0, borsh_1.field)('string')
], InternalError.prototype, "message", void 0);
InternalError = __decorate([
    (0, borsh_1.variant)(9)
], InternalError);
exports.InternalError = InternalError;
class SdkError extends Error {
    constructor(message) {
        super(message);
    }
    static publicKeyNotFound(addr) {
        return new SdkError(`RSA public key for ${addr} is missing`);
    }
    static gameAccountNotFound(addr) {
        return new SdkError(`Game account of ${addr} not found`);
    }
    static gameBundleNotFound(addr) {
        return new SdkError(`Game bundle of ${addr} not found`);
    }
    static transactorAccountNotFound(addr) {
        return new SdkError(`Transactor's account of ${addr} not found`);
    }
    static gameNotServed(addr) {
        return new SdkError(`Game at ${addr} is not served`);
    }
}
exports.SdkError = SdkError;
//# sourceMappingURL=error.js.map