var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { field, array, enums, option, variant, struct } from '@race-foundation/borsh';
import { PlayerJoin, ServerJoin } from './accounts';
export class SecretShare {
}
let Random = class Random extends SecretShare {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
};
__decorate([
    field('string')
], Random.prototype, "fromAddr", void 0);
__decorate([
    field(option('string'))
], Random.prototype, "toAddr", void 0);
__decorate([
    field('usize')
], Random.prototype, "randomId", void 0);
__decorate([
    field('usize')
], Random.prototype, "index", void 0);
__decorate([
    field('u8-array')
], Random.prototype, "secret", void 0);
Random = __decorate([
    variant(0)
], Random);
export { Random };
let Answer = class Answer extends SecretShare {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
};
__decorate([
    field('string')
], Answer.prototype, "fromAddr", void 0);
__decorate([
    field('usize')
], Answer.prototype, "decisionId", void 0);
__decorate([
    field('u8-array')
], Answer.prototype, "secret", void 0);
Answer = __decorate([
    variant(1)
], Answer);
export { Answer };
export class GameEvent {
}
let Custom = class Custom extends GameEvent {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
};
__decorate([
    field('string')
], Custom.prototype, "sender", void 0);
__decorate([
    field('u8-array')
], Custom.prototype, "raw", void 0);
Custom = __decorate([
    variant(0)
], Custom);
export { Custom };
export function makeCustomEvent(sender, customEvent) {
    return new Custom({
        sender,
        raw: customEvent.serialize(),
    });
}
let Ready = class Ready extends GameEvent {
    constructor(_ = {}) {
        super();
    }
};
Ready = __decorate([
    variant(1)
], Ready);
export { Ready };
let ShareSecrets = class ShareSecrets extends GameEvent {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
};
__decorate([
    field('string')
], ShareSecrets.prototype, "sender", void 0);
__decorate([
    field(array(enums(SecretShare)))
], ShareSecrets.prototype, "shares", void 0);
ShareSecrets = __decorate([
    variant(2)
], ShareSecrets);
export { ShareSecrets };
let OperationTimeout = class OperationTimeout extends GameEvent {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
};
__decorate([
    field(array('string'))
], OperationTimeout.prototype, "addrs", void 0);
OperationTimeout = __decorate([
    variant(3)
], OperationTimeout);
export { OperationTimeout };
let Mask = class Mask extends GameEvent {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
};
__decorate([
    field('string')
], Mask.prototype, "sender", void 0);
__decorate([
    field('usize')
], Mask.prototype, "randomId", void 0);
__decorate([
    field(array('u8-array'))
], Mask.prototype, "ciphertexts", void 0);
Mask = __decorate([
    variant(4)
], Mask);
export { Mask };
export class CiphertextAndDigest {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    field('u8-array')
], CiphertextAndDigest.prototype, "ciphertext", void 0);
__decorate([
    field('u8-array')
], CiphertextAndDigest.prototype, "digest", void 0);
let Lock = class Lock extends GameEvent {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
};
__decorate([
    field('string')
], Lock.prototype, "sender", void 0);
__decorate([
    field('usize')
], Lock.prototype, "randomId", void 0);
__decorate([
    field(array(struct(CiphertextAndDigest)))
], Lock.prototype, "ciphertextsAndDigests", void 0);
Lock = __decorate([
    variant(5)
], Lock);
export { Lock };
let RandomnessReady = class RandomnessReady extends GameEvent {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
};
__decorate([
    field('usize')
], RandomnessReady.prototype, "randomId", void 0);
RandomnessReady = __decorate([
    variant(6)
], RandomnessReady);
export { RandomnessReady };
let Sync = class Sync extends GameEvent {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
};
__decorate([
    field(array(struct(PlayerJoin)))
], Sync.prototype, "newPlayers", void 0);
__decorate([
    field(array(struct(ServerJoin)))
], Sync.prototype, "newServers", void 0);
__decorate([
    field('string')
], Sync.prototype, "transactorAddr", void 0);
__decorate([
    field('u64')
], Sync.prototype, "accessVersion", void 0);
Sync = __decorate([
    variant(7)
], Sync);
export { Sync };
let ServerLeave = class ServerLeave extends GameEvent {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
};
__decorate([
    field('string')
], ServerLeave.prototype, "serverAddr", void 0);
__decorate([
    field('string')
], ServerLeave.prototype, "transactorAddr", void 0);
ServerLeave = __decorate([
    variant(8)
], ServerLeave);
export { ServerLeave };
let Leave = class Leave extends GameEvent {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
};
__decorate([
    field('string')
], Leave.prototype, "playerAddr", void 0);
Leave = __decorate([
    variant(9)
], Leave);
export { Leave };
let GameStart = class GameStart extends GameEvent {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
};
__decorate([
    field('u64')
], GameStart.prototype, "accessVersion", void 0);
GameStart = __decorate([
    variant(10)
], GameStart);
export { GameStart };
let WaitingTimeout = class WaitingTimeout extends GameEvent {
    constructor(_ = {}) {
        super();
    }
};
WaitingTimeout = __decorate([
    variant(11)
], WaitingTimeout);
export { WaitingTimeout };
let DrawRandomItems = class DrawRandomItems extends GameEvent {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
};
__decorate([
    field('string')
], DrawRandomItems.prototype, "sender", void 0);
__decorate([
    field('usize')
], DrawRandomItems.prototype, "randomId", void 0);
__decorate([
    field(array('usize'))
], DrawRandomItems.prototype, "indexes", void 0);
DrawRandomItems = __decorate([
    variant(12)
], DrawRandomItems);
export { DrawRandomItems };
let DrawTimeout = class DrawTimeout extends GameEvent {
    constructor(_) {
        super();
    }
};
DrawTimeout = __decorate([
    variant(13)
], DrawTimeout);
export { DrawTimeout };
let ActionTimeout = class ActionTimeout extends GameEvent {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
};
__decorate([
    field('string')
], ActionTimeout.prototype, "playerAddr", void 0);
ActionTimeout = __decorate([
    variant(14)
], ActionTimeout);
export { ActionTimeout };
let AnswerDecision = class AnswerDecision extends GameEvent {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
};
__decorate([
    field('string')
], AnswerDecision.prototype, "sender", void 0);
__decorate([
    field('usize')
], AnswerDecision.prototype, "decisionId", void 0);
__decorate([
    field('u8-array')
], AnswerDecision.prototype, "ciphertext", void 0);
__decorate([
    field('u8-array')
], AnswerDecision.prototype, "digest", void 0);
AnswerDecision = __decorate([
    variant(15)
], AnswerDecision);
export { AnswerDecision };
let SecretsReady = class SecretsReady extends GameEvent {
    constructor(_ = {}) {
        super();
    }
};
SecretsReady = __decorate([
    variant(16)
], SecretsReady);
export { SecretsReady };
let Shutdown = class Shutdown extends GameEvent {
    constructor(_ = {}) {
        super();
    }
};
Shutdown = __decorate([
    variant(17)
], Shutdown);
export { Shutdown };
//# sourceMappingURL=events.js.map