export class ProfileCache {
    constructor(transport) {
        this.transport = transport;
        this.caches = new Map();
    }
    async getProfile(playerAddr) {
        let exist = this.caches.get(playerAddr);
        if (exist !== undefined) {
            return exist;
        }
        else {
            const p = await this.transport.getPlayerProfile(playerAddr);
            if (p === undefined) {
                return undefined;
            }
            else {
                this.caches.set(playerAddr, p);
                return p;
            }
        }
    }
    async injectProfiles(context) {
        for (let player of context.players) {
            const profile = await this.getProfile(player.addr);
            player.profile = profile;
        }
    }
}
//# sourceMappingURL=profile-cache.js.map