import { IConnection } from './connection';
import { IEncryptor } from './encryptor';
import { ITransport } from './transport';
import { GameContext } from './game-context';
import { Id } from './types';
export declare class Client {
    #private;
    constructor(addr: string, gameAddr: string, transport: ITransport, encryptor: IEncryptor, connection: IConnection);
    attachGame(): Promise<void>;
    submitEvent(event: any): Promise<void>;
    submitCustomEvent(customEvent: any): Promise<void>;
    handleDecision(ctx: GameContext): Promise<Event[]>;
    loadRandomStates(ctx: GameContext): void;
    handleUpdatedContext(ctx: GameContext): Promise<Event[]>;
    flushSecretStates(): void;
    decrypt(ctx: GameContext, randomId: Id): Promise<Map<number, string>>;
}
//# sourceMappingURL=client.d.ts.map